From de490e0590dabc8b30619092f9197ab0d4c47458 Mon Sep 17 00:00:00 2001
From: Marek 'marx' Grac <mgrac@redhat.com>
Date: Wed, 22 Mar 2017 20:27:57 +0100
Subject: [PATCH] fencing: Add consistency between command-line and STDIN
 arguments

---
 fence/agents/lib/fence2man.xsl               |  6 ++
 fence/agents/lib/fencing.py.py               | 49 +++++++++++-----
 fence/agents/lib/metadata.rng                |  3 +-
 tests/data/metadata/fence_alom.xml           | 56 ++++++++++++++++---
 tests/data/metadata/fence_amt.xml            | 42 ++++++++++++--
 tests/data/metadata/fence_amt_ws.xml         | 35 ++++++++++--
 tests/data/metadata/fence_apc.xml            | 56 ++++++++++++++++---
 tests/data/metadata/fence_apc_snmp.xml       | 42 ++++++++++++--
 tests/data/metadata/fence_azure_arm.xml      | 35 ++++++++++--
 tests/data/metadata/fence_bladecenter.xml    | 56 ++++++++++++++++---
 tests/data/metadata/fence_brocade.xml        | 56 ++++++++++++++++---
 tests/data/metadata/fence_cisco_mds.xml      | 42 ++++++++++++--
 tests/data/metadata/fence_cisco_ucs.xml      | 42 ++++++++++++--
 tests/data/metadata/fence_compute.xml        | 84 ++++++++++++++++++++++++----
 tests/data/metadata/fence_docker.xml         | 21 ++++++-
 tests/data/metadata/fence_drac.xml           | 49 +++++++++++++---
 tests/data/metadata/fence_drac5.xml          | 56 ++++++++++++++++---
 tests/data/metadata/fence_dummy.xml          |  7 ++-
 tests/data/metadata/fence_eaton_snmp.xml     | 42 ++++++++++++--
 tests/data/metadata/fence_emerson.xml        | 42 ++++++++++++--
 tests/data/metadata/fence_eps.xml            | 49 +++++++++++++---
 tests/data/metadata/fence_hds_cb.xml         | 56 ++++++++++++++++---
 tests/data/metadata/fence_hpblade.xml        | 56 ++++++++++++++++---
 tests/data/metadata/fence_ibmblade.xml       | 42 ++++++++++++--
 tests/data/metadata/fence_idrac.xml          | 49 +++++++++++++---
 tests/data/metadata/fence_ifmib.xml          | 42 ++++++++++++--
 tests/data/metadata/fence_ilo.xml            | 49 +++++++++++++---
 tests/data/metadata/fence_ilo2.xml           | 49 +++++++++++++---
 tests/data/metadata/fence_ilo3.xml           | 49 +++++++++++++---
 tests/data/metadata/fence_ilo3_ssh.xml       | 56 ++++++++++++++++---
 tests/data/metadata/fence_ilo4.xml           | 49 +++++++++++++---
 tests/data/metadata/fence_ilo4_ssh.xml       | 56 ++++++++++++++++---
 tests/data/metadata/fence_ilo_moonshot.xml   | 56 ++++++++++++++++---
 tests/data/metadata/fence_ilo_mp.xml         | 56 ++++++++++++++++---
 tests/data/metadata/fence_ilo_ssh.xml        | 56 ++++++++++++++++---
 tests/data/metadata/fence_imm.xml            | 49 +++++++++++++---
 tests/data/metadata/fence_intelmodular.xml   | 42 ++++++++++++--
 tests/data/metadata/fence_ipdu.xml           | 42 ++++++++++++--
 tests/data/metadata/fence_ipmilan.xml        | 49 +++++++++++++---
 tests/data/metadata/fence_ironic.xml         | 55 +++++++++++++++---
 tests/data/metadata/fence_ldom.xml           | 56 ++++++++++++++++---
 tests/data/metadata/fence_lpar.xml           | 56 ++++++++++++++++---
 tests/data/metadata/fence_mpath.xml          | 14 ++++-
 tests/data/metadata/fence_netio.xml          | 42 ++++++++++++--
 tests/data/metadata/fence_ovh.xml            | 35 ++++++++++--
 tests/data/metadata/fence_powerman.xml       | 21 ++++++-
 tests/data/metadata/fence_pve.xml            | 49 +++++++++++++---
 tests/data/metadata/fence_raritan.xml        | 42 ++++++++++++--
 tests/data/metadata/fence_rcd_serial.xml     |  7 ++-
 tests/data/metadata/fence_rhevm.xml          | 42 ++++++++++++--
 tests/data/metadata/fence_rsa.xml            | 56 ++++++++++++++++---
 tests/data/metadata/fence_rsb.xml            | 56 ++++++++++++++++---
 tests/data/metadata/fence_sanbox2.xml        | 49 +++++++++++++---
 tests/data/metadata/fence_sbd.xml            | 14 ++++-
 tests/data/metadata/fence_scsi.xml           | 13 ++++-
 tests/data/metadata/fence_tripplite_snmp.xml | 42 ++++++++++++--
 tests/data/metadata/fence_vbox.xml           | 63 ++++++++++++++++++---
 tests/data/metadata/fence_virsh.xml          | 63 ++++++++++++++++++---
 tests/data/metadata/fence_vmware.xml         | 49 +++++++++++++---
 tests/data/metadata/fence_vmware_soap.xml    | 42 ++++++++++++--
 tests/data/metadata/fence_wti.xml            | 56 ++++++++++++++++---
 tests/data/metadata/fence_xenapi.xml         | 35 ++++++++++--
 tests/data/metadata/fence_zvmip.xml          | 42 ++++++++++++--
 63 files changed, 2369 insertions(+), 403 deletions(-)

Index: fence-agents-4.0.25+git.1485179354.eb43835/fence/agents/lib/fence2man.xsl
===================================================================
--- fence-agents-4.0.25+git.1485179354.eb43835.orig/fence/agents/lib/fence2man.xsl
+++ fence-agents-4.0.25+git.1485179354.eb43835/fence/agents/lib/fence2man.xsl
@@ -2,6 +2,7 @@
 <xsl:output method="text" indent="no"/>
 <xsl:template match="parameter">
 <xsl:param name="show" />
+<xsl:if test="not(@deprecated)">
 .TP
 <xsl:if test="$show = 'getopt'">.B <xsl:value-of select="getopt/@mixed" /></xsl:if>
 <xsl:if test="$show = 'stdin'">.B <xsl:value-of select="@name"/></xsl:if>
@@ -19,6 +20,11 @@
 </xsl:if>
 <xsl:if test="not(content/@default)"><xsl:if test="@required = 1"> This parameter is always required.</xsl:if></xsl:if>
 <xsl:if test="content/@default"> (Default Value: <xsl:value-of select="content/@default"/>)</xsl:if>
+<xsl:if test="$show = 'stdin'">
+<xsl:if test="@obsoletes"> Obsoletes: <xsl:value-of select="@obsoletes" /></xsl:if>
+</xsl:if>
+
+</xsl:if>
 </xsl:template>
 
 <xsl:template match="action">
Index: fence-agents-4.0.25+git.1485179354.eb43835/fence/agents/lib/fencing.py.py
===================================================================
--- fence-agents-4.0.25+git.1485179354.eb43835.orig/fence/agents/lib/fencing.py.py
+++ fence-agents-4.0.25+git.1485179354.eb43835/fence/agents/lib/fencing.py.py
@@ -551,7 +551,12 @@ def usage(avail_opt):
 
 def metadata(avail_opt, docs):
 	# avail_opt has to be unique, if there are duplicities then they should be removed
-	sorted_list = [(key, all_opt[key]) for key in list(set(avail_opt))]
+	sorted_list = [(key, all_opt[key]) for key in list(set(avail_opt)) if "longopt" in all_opt[key]]
+	# Find keys that are going to replace inconsistent names
+	mapping = dict([(opt["longopt"].replace("-", "_"), key) for (key, opt) in sorted_list if (key != opt["longopt"].replace("-", "_"))])
+	new_options = [(key, all_opt[mapping[key]]) for key in mapping]
+	sorted_list.extend(new_options)
+
 	sorted_list.sort(key=lambda x: (x[1]["order"], x[0]))
 
 	print("<?xml version=\"1.0\" ?>")
@@ -562,34 +567,43 @@ def metadata(avail_opt, docs):
 	print("<longdesc>" + docs["longdesc"] + "</longdesc>")
 	print("<vendor-url>" + docs["vendorurl"] + "</vendor-url>")
 	print("<parameters>")
-	for option, _ in sorted_list:
-		if "help" in all_opt[option] and len(all_opt[option]["help"]) > 0:
-			print("\t<parameter name=\"" + option + "\" unique=\"0\" required=\"" + all_opt[option]["required"] + "\">")
+	for (key, opt) in sorted_list:
+		info = ""
+		if key in all_opt:
+			if key != all_opt[key].get('longopt', key).replace("-", "_"):
+				info = "deprecated=\"1\""
+		else:
+			info = "obsoletes=\"%s\"" % (mapping.get(key))
+
+		if "help" in opt and len(opt["help"]) > 0:
+			if info != "":
+				info = " " + info
+			print("\t<parameter name=\"" + key + "\" unique=\"0\" required=\"" + opt["required"] + "\"" + info + ">")
 
 			default = ""
-			if "default" in all_opt[option]:
-				default = "default=\"" + _encode_html_entities(str(all_opt[option]["default"])) + "\" "
+			if "default" in opt:
+				default = "default=\"" + _encode_html_entities(str(opt["default"])) + "\" "
 
-			mixed = all_opt[option]["help"]
+			mixed = opt["help"]
 			## split it between option and help text
 			res = re.compile(r"^(.*?--\S+)\s+", re.IGNORECASE | re.S).search(mixed)
 			if None != res:
 				mixed = res.group(1)
 			mixed = _encode_html_entities(mixed)
 
-			if not "shortdesc" in all_opt[option]:
-				shortdesc = re.sub("\s\s+", " ", all_opt[option]["help"][31:])
+			if not "shortdesc" in opt:
+				shortdesc = re.sub("\s\s+", " ", opt["help"][31:])
 			else:
-				shortdesc = all_opt[option]["shortdesc"]
+				shortdesc = opt["shortdesc"]
 
 			print("\t\t<getopt mixed=\"" + mixed + "\" />")
-			if "choices" in all_opt[option]:
+			if "choices" in opt:
 				print("\t\t<content type=\"select\" "+default+" >")
-				for choice in all_opt[option]["choices"]:
+				for choice in opt["choices"]:
 					print("\t\t\t<option value=\"%s\" />" % (choice))
 				print("\t\t</content>")
-			elif all_opt[option]["getopt"].count(":") > 0:
-				t = all_opt[option].get("type", "string")
+			elif opt["getopt"].count(":") > 0:
+				t = opt.get("type", "string")
 				print("\t\t<content type=\"%s\" " % (t) +default+" />")
 			else:
 				print("\t\t<content type=\"boolean\" "+default+" />")
@@ -1297,14 +1311,21 @@ def _prepare_getopt_args(options):
 def _parse_input_stdin(avail_opt):
 	opt = {}
 	name = ""
+
+	mapping_longopt_names = dict([(all_opt[o].get("longopt"), o) for o in avail_opt])
+
 	for line in sys.stdin.readlines():
 		line = line.strip()
 		if (line.startswith("#")) or (len(line) == 0):
 			continue
 
 		(name, value) = (line + "=").split("=", 1)
+		name = name.replace("-", "_");
 		value = value[:-1]
 
+		if name in mapping_longopt_names:
+			name = mapping_longopt_names[name]
+
 		if avail_opt.count(name) == 0 and name in ["nodename"]:
 			continue
 		elif avail_opt.count(name) == 0:
Index: fence-agents-4.0.25+git.1485179354.eb43835/fence/agents/lib/metadata.rng
===================================================================
--- fence-agents-4.0.25+git.1485179354.eb43835.orig/fence/agents/lib/metadata.rng
+++ fence-agents-4.0.25+git.1485179354.eb43835/fence/agents/lib/metadata.rng
@@ -19,7 +19,8 @@
 			<attribute name="name" />
 			<attribute name="unique"> <ref name="boolean-values" /> </attribute>
 			<attribute name="required"> <ref name="boolean-values" />  </attribute>
-
+			<optional><attribute name="deprecated"> <ref name="boolean-values" /></attribute></optional>
+			<optional><attribute name="obsoletes" /> </optional>
 			<element name="getopt">
 				<attribute name="mixed" />
 			</element>
